#include "channel.h"

PChannel AllocateChannel(unsigned senders, unsigned receivers, unsigned channels)
{
  unsigned i;
  unsigned total_channels=senders*receivers*channels;
  PChannel c=(PChannel)SafeMalloc(sizeof(TChannel),
				   "AllocateChannel: can not allocate channel struct\n");
  c->senders=senders;
  c->receivers=receivers;
  c->channels=channels;

  c->channel=(PTransfer *)SafeMalloc(sizeof(PTransfer)*total_channels,
				      "AllocateChannel: can not allocate channel buffer\n");
  
  for(i=0;i<total_channels;i++)
    c->channel[i]=INVALID_TRANSFER;
  return c;
}

