#ifndef __CHANNEL_H__
#define __CHANNEL_H__

#include "spmd_comm.h"

typedef struct _TChannel {
  unsigned senders, receivers, channels;
  PTransfer *channel;
} TChannel, *PChannel;

#define Channel(c, s, r, i) (c->channel[(s*c->receivers+r)*c->channels+i])
#define ChannelIndex(c, s, r, i) ((s*c->receivers+r)*c->channels+i)

#ifdef __cplusplus
extern "C" {
#endif

extern PChannel AllocateChannel(unsigned senders, unsigned receivers, unsigned channels);

#ifdef __cplusplus
}
#endif

#endif
